
; = Info ===========================================================================================
; Title           : hover effect easy PB
; --------------------------------------------------------------------------------------------------
;
; Demo: Professor Bernd, 2020-08-28.
;
; Der Code basiert auf der hervorragenden Lsung von "Health" (AutoIt DE Forum).
; The code is based on the excellent solution of "Health" (AutoIt DE Forum).
;
; Autor der ursprnglichen Funktion / Author of the original function: Health, 2008-04-30.
; Quelle: https://autoit.de/thread/6087-control-hover-effekt-ohne-fehler/
;
; Modifikation / Modification: Professor Bernd, 2020-08-18 ...
; ==================================================================================================

#include <GUIConstantsEx.au3>

Opt("MustDeclareVars", 1)

; create GUI and controls
Global $hGui = GUICreate("Hover the controls!", 480, 220)
Global $g_Button = GUICtrlCreateButton("Button", 30, 60, 100, 30)
Global $g_Label = GUICtrlCreateLabel("Label", 90, 20, 80, 20)
GUICtrlSetCursor(-1, 0)
GUICtrlSetFont(-1, 14, -1, 0, "Arial")
Global $g_Edit = GUICtrlCreateEdit("I like yellow...", 220, 30, 160, 80)
Global $g_Icon = GUICtrlCreateIcon("shell32.dll", 7, 120, 110, 32, 32)
GUISetState(@SW_SHOW)


; main loop
While 1
  Hover_ShowEffects()
  If GUIGetMsg() = $GUI_EVENT_CLOSE Then ExitLoop
WEnd


; hover function
Func Hover_ShowEffects()

  Local Static $idHoveredCtrl_Old
  Local $aCInfo = GUIGetCursorInfo($hGui) ; it's important that the gui variable is setted in this function!

  ; $aCInfo[4] = ID of the control that the mouse cursor is hovering over (or 0 if none).
  If $aCInfo[4] <> $idHoveredCtrl_Old Then

    ; reset the previous control
    Switch $idHoveredCtrl_Old
      Case $g_Button
        GUICtrlSetData($idHoveredCtrl_Old, "Button")
      Case $g_Label
        GUICtrlSetFont($idHoveredCtrl_Old, 14, -1, 0, "Arial")
      Case $g_Edit
        GUICtrlSetBkColor($idHoveredCtrl_Old, -1)
      Case $g_Icon
        GUICtrlSetImage($idHoveredCtrl_Old, "shell32.dll", 7)
    EndSwitch

    ; set the new control hovered
    Switch $aCInfo[4]
      Case $g_Button
        GUICtrlSetData($aCInfo[4], "Don't press!")
      Case $g_Label
        GUICtrlSetFont($aCInfo[4], 14, 800, 0, "Arial")
      Case $g_Edit
        GUICtrlSetBkColor($aCInfo[4], 0xFFFF00) ; yellow
      Case $g_Icon
        GUICtrlSetImage($aCInfo[4], "shell32.dll", 10)
        Beep(500, 50) ; for demonstration
    EndSwitch

    $idHoveredCtrl_Old = $aCInfo[4]
  EndIf
EndFunc ; ==> Hover_ShowEffects
